<?php
################################################################################
### This disclaimer must be kept intact in order to use this product.        ###
################################################################################
### Project: jT CarFramework [http://intersofts.com]
### Author: J. Toshio Taniguchi
### Since: 27.04.2011
### Version: 1.0.0
### Copyrights: J. Toshio Taniguchi
### Contact: j.taniguchi@taniguchi-blog.com
################################################################################
### CONTRIBUTORS
### - none
################################################################################
class admincreatemenu 
{
    private   $lang;
    protected $form_status = false;
    protected $form_message;
    protected $form_style;
    protected $group_list;
    
    /*
     * Constructor -------------------------------------------------------------
     */
    public function admincreatemenu($lang=array())
    {
        $this->lang = $lang;
        
        // load menu group.
        $this->loadGroupList();
        
        // handle save new menu.
        if( isset($_POST['saveBtn']) )
        {
            $this->handleSaveForm();
        }
        
        // handle update menu form.
        if( isset($_POST['updateBtn']) )
        {
            $this->handleUpdateForm();
        }
        
        // handle delete menu form.
        if( isset($_POST['deleteBtn']) )
        {
            $this->handleDeleteForm();
        }
    }
    
    /*
     * Private method: handle delete menu. -------------------------------------
     */
    private function handleDeleteForm()
    {
        $menuId = trim($_POST['mid']);
        $cOrder = trim($_POST['sorder']); // current order number.
        
        // validate.
        if( !is_numeric($cOrder) || !is_numeric($menuId) )
        {
            $this->form_message = $this->lang['MENU_NEW_REMOVE_INVALID_REQUEST'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            return;
        }
        
        // connect to database.
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        // get the menu list and re-order it.
        if( !$sql = @mysql_query("SELECT `id`,`order` FROM `menu_topic` ORDER BY `order` ASC") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to remove menu from database due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_NEW_REMOVE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        if( mysql_num_rows($sql) > 0 ) // of course it will...duh
        {
            $list = array();
            
            while( $r = mysql_fetch_assoc($sql) )
            {
                if( $r['id'] != $menuId )
                {
                    $obj = array();
                    $obj['id'] = $r['id'];
                    $obj['order'] = $r['order'];
                    
                    array_push($list, $obj);
                }
            }
            
            @mysql_free_result($sql);
            
            // reorder it on database. this is a ugly way to do this but I'll 
            // redo it later...
            for( $i=0; $i < count($list); $i++ )
            {
                $count = ($i+1);
                $lid = $list[$i]['id'];
                
                @mysql_query("UPDATE `menu_topic` SET `order`='$count' WHERE `id`='$lid' LIMIT 1;");
            }
        }
            
        // remove the menu.
        if( !@mysql_query("DELETE FROM `menu_topic` WHERE `id`='$menuId' LIMIT 1;") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to remove menu from database due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_NEW_REMOVE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        $cnx->close();
        
        $this->form_message = $this->lang['MENU_NEW_REMOVE_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        
        return;
    }
    
    /*
     * Private method: handle update menu form ---------------------------------
     */
    private function handleUpdateForm()
    {
        $menuId = trim($_POST['mid']);
        $cOrder = trim($_POST['sorder']); // current order number.
        $nOrder = trim($_POST['order_input']); // new order index.
        $label  = trim($_POST['name_input']);
        $enabled= trim($_POST['publish_input']);
        $group  = trim($_POST['group_input']);
        
        // validate.
        if( strlen($label) < 3 )
        {
            $this->form_message = $this->lang['MENU_NEW_INVALID_LABEL_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            return;
        }
        
        if( !is_numeric($menuId) )
        {
            $this->form_message = $this->lang['MENU_NEW_INVALID_UPDATE_REQUEST'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            return;
        }
        
        ( (bool)$enabled ? $enabled = '1' : $enabled = '0' );
        
        if( empty($group) )
        {
            $group = 'public';
        }
        
        // define order.
        $order = $cOrder;
        
        if( $cOrder != $nOrder )
        {
            $order = $nOrder;
        }
        
        // connect to database.
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        // filter data.
        $label = mysql_real_escape_string($label);
        
        // update the row in which the new order will be replaced.
        if( $cOrder != $nOrder )
        {
            // get row id from the new order.
            if( !$sql = mysql_query("SELECT `id`,`order` FROM `menu_topic` WHERE `order`='$nOrder' LIMIT 1;") )
            {
                require_once BASE_ROOT . 'core/class-log.php';
            
                LogReport::write('Unable to update menu_topic table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());

                $cnx->close();

                $this->form_message = $this->lang['MENU_NEW_UPDATE_QUERY_ERROR'];
                $this->form_status = true;
                $this->form_style = 'alert-warning';

                return;
            }
            
            // it should have 1 row.
            if( mysql_num_rows($sql) != 1 )
            {
                require_once BASE_ROOT . 'core/class-log.php';
            
                LogReport::write('Unable to update menu_topic table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());

                $cnx->close();

                $this->form_message = $this->lang['MENU_NEW_UPDATE_QUERY_ERROR'];
                $this->form_status = true;
                $this->form_style = 'alert-warning';

                return;
            }
            
            $od = mysql_fetch_assoc($sql);
            @mysql_free_result($sql);
            
            // update replaced order.
            if( !@mysql_query("UPDATE `menu_topic` SET `order`='$cOrder' WHERE `id`='".$od['id']."' LIMIT 1;") )
            {
                require_once BASE_ROOT . 'core/class-log.php';
            
                LogReport::write('Unable to update menu_topic table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());

                $cnx->close();

                $this->form_message = $this->lang['MENU_NEW_UPDATE_QUERY_ERROR'];
                $this->form_status = true;
                $this->form_style = 'alert-warning';

                return;
            }
        }
        
        // update the current order.
        if( !@mysql_query("UPDATE `menu_topic` SET `label`='$label', `order`='$order', `enabled`='$enabled', `group`='$group' WHERE `id`='$menuId' LIMIT 1;") )
        {
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to update menu_topic table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $cnx->close();
            
            $this->form_message = $this->lang['MENU_NEW_UPDATE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        $this->form_message = $this->lang['MENU_NEW_UPDATE_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        
        return;
    }
    
    /*
     * Private method: handle save new menu form -------------------------------
     */
    private function handleSaveForm()
    {
        $name = trim($_POST['nameInput']);
        $enabled = trim($_POST['publishInput']);
        $group = trim($_POST['groupInput']);
        
        // validate.
        if( strlen($name) < 3 )
        {
            $this->form_message = $this->lang['MENU_NEW_INVALID_MENU_LABEL_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            return;
        }
        
        $enabled = (bool)$enabled;
        ( $enabled ? $enabled = '1' : $enabled = '0' );  
        
        if( empty($group) )
        {
            $group = 'public';
        }
        
        // connect to db.
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        // filter input.
        $name = mysql_real_escape_string($name);
        $group = mysql_real_escape_string($group);
        
        // get last order.
        if( !$sql = mysql_query("SELECT `order` FROM `menu_topic`") )
        {
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to save menu due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_NEW_SAVE_LOAD_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            $cnx->close();
            
            return;
        }
        
        $oarr = array();
        
        if( mysql_num_rows($sql) > 0 )
        {
            while( $r = mysql_fetch_assoc($sql) )
            {
                array_push($oarr,$r['order']);
            }
            
            @mysql_free_result($sql);
        }
        
        $order = 0;
        
        for( $i=0; $i < count($oarr); $i++ )
        {
            if( $oarr[$i] > $order )
            {
                $order = $oarr[$i];
            }
        }
        
        $order++;
        
        // register menu to database.
        if( !mysql_query("INSERT INTO `menu_topic` (`label`,`order`,`enabled`,`group`) VALUES ('$name','$order','$enabled','$group')") )
        {
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to save menu due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_NEW_SAVE_INSERT_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            $cnx->close();
            
            return;
        }
        
        $cnx->close();
        
        $this->form_message = $this->lang['MENU_NEW_SAVE_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        
        return;
    }
    
    /*
     * Private method: load group list. ----------------------------------------
     * @return array.
     */
    private function loadGroupList()
    {
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        if( !$sql = mysql_query("SELECT * FROM `group`") )
        {
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to load group list due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $cnx->close();
            
            $this->group_list = array();
            
            return;
        }
        
        if( mysql_num_rows($sql) < 1 )
        {
            $cnx->close();
            $this->group_list = array();
            
            return;
        }
        
        $result = array();
        
        while( $r = mysql_fetch_assoc($sql) )
        {
            array_push($result, $r['group']);
        }
        
        @mysql_free_result($sql);
        
        $cnx->close();
        
        $this->group_list = $result;
        
        return;
    }
    
    /*
     * Public method: get group list. ------------------------------------------
     * @return array.
     */
    public function getGroups()
    {
        return $this->group_list;
    }
    
    /*
     * Public method: load menu list. ------------------------------------------
     * @return array | false.
     */
    public function getMenuList()
    {
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        if( !$sql = @mysql_query("SELECT * FROM `menu_topic` ORDER BY `order` ASC") )
        {
            require_once BASE_ROOT . 'core/class-log.php';
            
            $cnx->close();
            
            LogReport::write('Unable to load menu topic list due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_NEW_LOAD_LIST_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return false;
        }
        
        if( mysql_num_rows($sql) < 1 )
        {
            $cnx->close();
            return array();
        }
        
        $result = array();
        
        while( $r = mysql_fetch_assoc($sql) )
        {
            $obj = array();
            $obj['id'] = $r['id'];
            $obj['label'] = $r['label'];
            $obj['order'] = (int)$r['order'];
            $obj['enabled'] = (bool)$r['enabled'];
            $obj['group'] = $r['group'];
            
            array_push($result, $obj);
        }
        
        @mysql_free_result($sql);
        $cnx->close();
        
        return $result;
    }

    /*
     * Public method: get form status ------------------------------------------
     * @return bool.
     */
    public function getFormStatus()
    {
        return $this->form_status;
    }
    
    /*
     * Public method: get form style -------------------------------------------
     * @return string (alert-error|alert-warning|alert-info)
     */
    public function getFormStyle()
    {
        return $this->form_style;
    }
    
    /*
     * Public method: get form message -----------------------------------------
     * @return string.
     */
    public function getFormMessage()
    {
        return $this->form_message;
    }
}
?>
